Subject: Linux Frequently Asked Questions 4/4 [monthly posted]
From: [email-masked]
Date: Thu, 18 Feb 1993 17:41:31 GMT
Newsgroups: comp.os.linux,comp.os.linux.announce,news.answers,comp.answers

Archive-name: linux-faq/part4
Last-Modified: 93/02/18
Version: 1.16.1

*********************************************************
*							*
*   Answers to Frequently asked questions about Linux   *
*							*
*********************************************************

This post contains Part 4 of the Linux FAQ (4 parts).
It must be read *after* the 3 first parts. 

===================================8<====>8============================
CONTENTS (of this part)

	IX. 	GCC MISC INFORMATION		(part4)
	X.	SCSI SPECIAL			(part4)
	XI.	NETWORKING and LINUX		(part4)
	XII.	X11, THE MAXIMUM and MORE	(part4)
	XIII.	EMACS for LINUX			(part4)

===================================8<====>8============================

IX. GCC MISC INFORMATION
========================

**** Last update 93/01/16

IX.A. HLU Information
IX.B. OTHERS

IX.A. HLU Information
~~~~~~~~~~~~~~~~~~~~~

The official release of GCC for Linux is 2.3.3.
This section includes:
	README.gccdisk
	FAQ of gcc written by HLU

QUESTION: I don't know how to install gcc stuff, is there special
places?

ANSWER: This is the README.gccdisk

                    Linux GNU C/C++ [HJ release]

Introduction
------------
  This is GNU C/C++ 2.3.3. It is linked with jump table 4.2. You should use
  it with the Linux C library disks since the C/C++ compiler has no shared
  images, which are required by all the binaries in it.  It consists of
  2 minix disks, which will fit on either 5.25" or 3.5" floppies.

  It is on tsx-11.mit.edu under pub/linux/GCC/gccdisk

Distribution File Format
------------------------
There are two files, each of which goes on one disk

  A. Disk 1 (gcc233a.Z)

  This contains gcc, cpp, cc1 and crt0.o/gcrt0.o.  There are also some header
  files in /usr/lib/gcc-lib/i386-linux/2.3.3/include.

  B. Disk 2 (gcc233b.Z)

  This disk contains cc1plus.

Installing on the Hard Drive
----------------------------------------
  1. uncompress base[1|2].Z.
  2. rawrite or dd each file to a formatted floppy disk.

  Now you have made a copy of gcc 2.3.3 on two floppies.  To copy each
  floppy to your hd, you should mount the floppy and copy its contents to
  your hard drive.  You can do this by:

    mount /dev/fd[0|1] /mnt
    cd /mnt
    for d in bin dev etc usr
    do
      if [ -d $d ]; then
        cp -av $d /
      fi
    done

  Note: This may overwrite some files on your hard disk.

Thanks.

H.J.
[email-masked]
12/31/92

QUESTION: What compiler should I use for Linux?

ANSWER: You should only use the same version on tsx-11.mit.edu or
fgb1.fgb.mw.tu-muenchen.de under /pub/linux/GCC. If you want to use
the testing release, first join the GCC channel on the Linux mailing
list, and then send a note to [email-masked]. Don't use gcc older
than the one on tsx-11.mit.edu or fgb1.fgb.mw.tu-muenchen.de.

QUESTION: Where is the latest official gcc 2.xx for Linux?

ANSWER: It's on tsx-11.mit.edu under /pub/Linux/GCC and
fgb1.fgb.mw.tu-muenchen.de under pub/linux/GCC. You may find it on the
other sites.

QUESTION: What are the contents of them?

ANSWER: Please read the current release note and ChangeLog for
details.

QUESTION: How do I install it?

ANSWER: Read README and release notes.

QUESTION: What are the main differences with the old release?

ANSWER: Read README and release notes.

QUESTION: Can I use the old version of gcc?

ANSWER: Please get rid of gcc older than gcc 2.2.2. Starting from
gcc 2.2.2, you can do

	gcc -V xxxx

where xxxx is the version number. Please read `release.xxxx' for
detail. There is one catch in gcc 2.2.2d, setjmp/longjmp is changed,
so the old header files is not compatible with gcc 2.2.2. Before you
install gcc 2.2.2d, please do

cp /usr/include/setjmp.h /usr/lib/gcc-lib/i386-linux/2.2.2/include

where /usr/include/setjmp.h is come with gcc 2.2.2.

QUESTION: Is stdio ANSI compatible?

ANSWER: Yes, please test it.

QUESTION: Is g++ in 2.xx?

ANSWER: Yes.

QUESTION: How do I use gcc?

ANSWER: Read manual page, gcc.ps or gcc.man in /usr/install/gcc2.

QUESTION: What options can I use for gcc?

ANSWER: Read manual page, gcc.ps or gcc.man. Also -static tells gcc
to use the static libraries, -nojump forces gcc to use the classic
shared libraries. The default is the jump table version of shared
libraries. The shared libraries for X are linked with the jump table
version of shared C library.

QUESTION: Where is the source code of the new libc.a?

ANSWER: The same place you find this file. It is called 
lib-src-yy.xx.TZ.

QUESTION: Why does g++ complain, even die?

ANSWER: You need "expr", which is in GNU shell utilities 1.6, echo (?)
and sed.

QUESTION: How do I generate code for 486?

ANSWER: Add -m486 to CFLAGS.

QUESTION: I heard malloc (0) wouldn't work with Linux, what should I
do?

ANSWER: include <stdlib.h> and don't define NO_FIX_MALLOC.

QUESTION: Why does gcc say "xxxxx..h not found"?

ANSWER: see QUESTION: What are the contents of them?

QUESTION: I really followed every step in the documentation, but when
I do "make", why does it say "don't how to make xxxxxx"?

ANSWER: The dependency in Makefile is dated, you need to make a new
one. Please get some guide on make and read Makefile. For the kernel
sources, please do

cd src/linux
make dep

QUESTION: How do I compile programs under Linux?

ANSWER: The Linux C library is trying to be ANSI/POSIX compliant. It
is also very compatible with SYSV and BSD. The C library is loaded
with SYSV and BSD functions. There are three exceptions:

1. signal in Linux is POSIX.
2. tty in Linux is POSIX.
3. time functions are POSIX, plus a few BSD and SYSV extensions.
4. setjmp/longjmp functions are POSIX. But you can use -D__FAVOR_BSD
   to make it BSD or use sigsigjmp/siglongjmp.

When you compile a program under Linux, your best bet is include all
the appropriate header files and use -Wall. All the usable functions
and global variables are declared in the corresponding header files.
YOU SHOULD NOT DEFINE ANY functions or global variables OF THE LINUX C
LIBRARY IN YOUR CODE IF YOU WANT TO USE THE SHARED LIBRARIES.

After saying all those, you now should know you can compile a program
with -D_POSIX_SOURCE or -D_GNU_SOURCE (read <features.h> for details).
With a few modifications you can even use -DSYSV, -DUSG or -DBSD. Some
codes need to define -DSTDC_HEADERS for ANSI C compiler like gcc here.

To use malloc () and calloc () safely under Linux, please include

<stdlib.h> and don't define NO_FIX_MALLOC.

BTW, gcc -traditional should work with gcc 2.2.2d or above.

Please also read ChangeLog for the latest enhencement.

Please read the header files for details. Maybe you should get a book
on POSIX. Any suggestion of the book list?

From Steve Robbins  --  [email-masked]

IX.B. OTHERS
~~~~~~~~~~~~

QUESTION: I seem to be unable to compile anything with gcc. Why?

ANSWER: If you have only 2 MB RAM, gcc will die silently without
compiling anything. You must have at least 4 MB to do compilations

BTW Since swapping is possible, I have heard that compilation works 
with only 2Meg and a lot disk traffic :) Isn't it great?

QUESTION: gcc complains about not finding crt0.o and the system
include files What am I doing wrong ?

ANSWER: The include files normal place is in /usr/include. lib*.a and
*.o should be in /usr/lib or /usr/local/lib

QUESTION: I tried to port a /new/ version of gnu stuff. But in the
linking phase, gcc complains about the missing libg.a. 

ANSWER: Yes this is well known for compiler version earlier than
2.2.2, throw away the flag -g that's all, anyway libg.a is /only/ for
debugging purpose. 

QUESTION: How to compile programs which may be debugged with gdb?

ANSWER: There are different ways to handle this problem. If
you have the gcc2.2.2 or later it's simple, use the -g flag. Otherwise
there are different possibilities:
1) As there is no libg.a, you should throw away the -g flag in link
phase, this means that the compilation must be done in two steps
example: instead of "gcc -g monprog.c -o monprog", use the following
"gcc -g -c monprog.c" and then "gcc -o monprog monprog.o"
Alas this method is not that good if you are using Makefile.
2) The other way is to create an empty libg.a as follows (Peter
MacDonald trick):
- create libfake.c containing libgfake() {}
- compile it with: gcc -c libfake.c
- create the libg.a with: ar r libg.a libfake.o
2bis) The more tricky Humberto method:
cd /usr/lib
ranlib libg.a

then gcc -g monprog.c -o monprog will produce a debuggable monprog

QUESTION: When compiling some code, cc1 complains about some insn
code, what's that? 

ANSWER: An insn is an internal representation that gcc uses when
compiling. The main part of gcc is to take ordinary c (or c++) code,
and compile it, while ding optimizations in insn part, which is
soft/hard independant. Then another part which is hard/Os dependant
takes the insns and translate it in assembly language. The fix is only
to turn off the optimization flag (-O). 

QUESTION: When compiling #$@!, I've got some problems with "SIGBUS"
signal that doesn't exist. Any clue ?

ANSWER: (Louis J. LaBash, Jr.) SIGBUS is a common problem, its not
needed, just comment it all out, something like:

#ifdef SIGBUS
.. normal sigbus code ..
#endif

QUESTION: How can I write codes suitable for building shared library ?

ANSWER: (H.J. Lu, [email-masked], 09/01/92)
There are some guidelines for writing codes suitable for building the
shared library with jump table.

1. Never, ever allow library users to access global data directly.
   Always, always make them go through access functions.  That way,
   you are free to change the internal implementation, but can
   easily provide backward compatibility by simply replacing the
   access functions.

2. If you do have to define some global data for library users to
   access, put them into a separate file. Never mix them with other
   library code. Also make sure the relative locations of the global
   data will not change very often. One solution is leave some spaces
   for them to grow.

X. SCSI SPECIAL
===============
*** This section is written by Drew Eckhardt, mail him for any
*** information, questions related to this section.
*** Last update December 1992.

QUESTION: What SCSI hosts are supported?

ANSWER: The Adaptec 154x, Adaptec 174x Future Domain 16x0,  Seagate ST0x, 
Ultrastor 14F, and Western Digital 7000 are supported.  Various Adaptec 
clones from Bustek and Future Domain are known to work, in both ISA and EISA 
flavors.

The TMC 950, and the discrete 8xx implementations will be supported 
in the new Seagate driver when debugging is finished.  If you want to 
use an older kernel, add 0x200 to the status and data register addresses.

Not very many BIOS signatures are included for the Future domain boards, so 
they may not auto-detect correctly.  

QUESTION: Which disks ?

ANSWER: Anything that works with your host adapter electronically, and
is new enough to support a December 1985 draft of SCSI-I.  

Sysquest, and other removeable hard disks are supported.

Extended partitions also work, with 11 Extended partitions per disk 
allowed in combination with the four real partitions and whole disk
sub device.

Disks up to two terabytes in size will work, since the sd driver
switches to 10 byte reads when necessary.

QUESTION: What about SCSI tapes ? 

ANSWER: Tapes are supported.  You may wish to obtain the utility program mt,
which is usually available from tsx-11.mit.edu in pub/linux/ALPHA/scsi.

QUESTION: What about CD ROMS?

ANSWER: Yes, cdroms are supported, and the ISO-9660 file system is in
included with the kernel distribution.  Rockridge extensions are
supported.  You will have to make sure that you have configured the
kernel to include the isofs filesystem or otherwise you will not be
able to use the cdrom.

QUESTION: What about flopticals, Bernoulis, Sysquests, and other removeable
media devices?

ANSWER: The normal SCSI disk driver supports these.  Note that pre-.98pl4
versions of Linux had some bugs handling disk-change.

QUESTION: How do I get SCSI information?

ANSWER: Subscribe to the SCSI channel of the linux-activists mailing list.
mail [email-masked] 
And put in the header.
       X-MN-Admin: join SCSI

QUESTION :  I can't make a filesystem on /dev/hd*

ANSWER : /dev/hd* aren't your SCSI disks.  /dev/sd* are. 
See below for approproate major / minor numbers if they 
do not exist on your root diskette.

QUESTION: How do I partition the disk?

ANSWER: Use pfdisk or the DOS parititioning program of your choice

QUESTION: My partitioning program can't figure out the disk geoemetry

The problem with partitioning SCSI disks and Linux is that Linux talks
directly to the SCSI interface.  Each disk is viewed as the SCSI host
sees it : N blocks, numbered from 0 to N-1, all error free.  There is
no portable way to get disk geometry.  

However, DOS doesn't like things like this, it demmands that BIOS
present it with a normal Cylinder / Head / Sector coordinates.  So,
BIOS does, and it comes up with some fabrication that fits what DOS
wants to see.  You don't want to disagree with what BIOS thinks when
you write the partition table. 

The newest SCSI code will return the mapped geometry for some host 
adapter / disk combinations.  Kernel release 0.99 and later should have
this capability.

QUESTION: The stock {f,pf}disk programs don't work.

ANSWER: At least some older versions of these partitioning programs have 
/dev/hd* hardcoded into them, and they don't see /dev/sd*.

If you want, YOU can change the /dev/hd* devices to be links to or
other entries for the SCSI devices.  

Also, pfdisk should be callable with a device name.

Hopefully, some one will change the partitioning programs to respect
the SCSI devices. 

QUESTION: Where is the latest version maintained?

ANSWER: tsx-11.mit.edu:/pub/linux/ALPHA/scsi

Join the list before you grab anything.

[email-masked] (Eric Youngdale) added scatter/gather support 
to the SCSI drivers, and changed around the internal structures to get 
something that works as "version 2"

QUESTION: What are the major / minor numbers for SCSI drives?

ANSWER: Because of the large number of devices that can be hung off of 
a SCSI bus (as many as 56 if you use SCSI fanouts or bridge boards), 
and the possibility of 16 partitions on a SCSI disk, we'd run out of 
minor numbers if they were statically allocated - so a dynamic 
numbering scheme is used.

Block device major 8 is used for SCSI drives, 11 for CD-ROMs.  
Character device major 9 is used for SCSI tapes.
        
Minors are assigned in increments of 16 to SCSI disks as they are
found, scaning from host 0, ID 0 to host n, ID 7, excluding the host
ID.  Most hosts use ID 7 for themselves.

A minor where minor mod 16 = 0 is the whole drive, where minor mod 16
is between 1 and 4, that partition, extended partitions dynamically
assigned from 5 to 15 inclusive.  Note that the gendisk.c module
prints partition tables on initialization - you should be able to see
them there.

Example : I have four SCSI disks, set up as follows 
        Seagate ST02, ID=0
        Seagate ST02, ID = 5
        Ultrastor 14, ID = 0
        Adaptec 1542, ID = 0

The first disk on the seagate at ID 0 will become minors 0-15
inclusive, the second at ID5 16-31 inclusive, the disk on the
Ultrastor 32-47, on the Adaptec 48-63.

QUESTION: How do I reduce kernel bloat and eliminate the drivers I
don't want?

ANSWER: For kernel release 0.99 and later, just go to the to directory
in the kernel source tree, and type ``make config'', and answer the
questions.  For older kernel distributions, simply #undef
CONFIG_DISTRIBUTION in include/linux/config.h, and define the macros
for the SCSI hosts you want enabled.

QUESTION: I get SCSI timeouts.

ANSWER: Make sure your board has interrupts enabled correctly.

QUESTION: The seagate driver doesn't work.

ANSWER: There are several possibilities
1) Is the board jumpered for IRQ5 ? 

The factory settings are
for MSLOSS, and have interrupts disabled.  Interrupts are controlled
by the W3 (ST01) or JP3 (ST02) jumper, which should have pins FG 
shorted.  See your manual.

2) Cached machines will not have problems IF the Seagate's address
space (typically C8000 - CAFFFF) is not marked "non cacheable."
This applies to the i486 internal cache as well as i386/i486 
external caches.

This can be set in the XCMOS of most machines.  If you can't disable
cache for the Seagate's area (16K in size, starting at the base
address), then you must disable the cache entirely, otherwise
it won't work.

3) The new seagate drivers (not yet released) can operate in a mode where 
the 0ws ISA bus line is used to synchronize the ISA and SCSI busses.  
This makes things fast, since the alpha Seagate driver can dump SCSI data out 
fast enough to swamp the bus.  However, this will only work if the 0ws 
jumper is enabled.  If this isn't the case, the Seagate driver "should" detect 
this as an over/under run condition, but it might not.  Either enable
the 0ws jumper, or #undef FAST in seagate.h.

QUESTION: The Adaptec driver doesn't work.

ANSWER: Older versions of the SCSI drivers required that the Adaptec BIOS
be enabled because it does some initialization that affects
the driver.  If the BIOS was disabled, it may fail on your system.
The new scsi code does not require this.
 
A common source of difficulty is a conflict between two different
boards forand IRQ level, a DMA channel, or an I/O address.  Check the
settings for the boards you have in your system (music boards are
known to use similar IRQ or I/O addresses as the Adaptec.  In the new
scsi code the Adaptec can use any of the IRQ levels that it can be
strapped for, it can use I/O address 0x330 or 0x334, and it can use
DMA channels 5, 6 or 7.

Older versions of the SCSI drivers ran the 17 x in 1542 emulation
mode, where some of these cards have a bug that interferes with
reads / writes > 512 bytes.

Older versions of the SCSI drivers ran the 174x in 1542 emulation
mode, where some of these cards have a bug that interferes with 
reads / writes > 512 bytes. 

The new SCSI drivers support the 174x in 'native' mode, so this isn't
a problem.

QUESTION: What about bugs?

ANSWER: It works on MY hardware.  It works on Tommy Thorn's Adaptec
system, Dave Gentzel's Ultrastor, Thomas Wuensche's WD7000, Rick
Faith's Future Domain, and quite a few other systems.

Bugs that are there will mostly be very hardware specific, and nasty
to track down.  SCSI should be basically error free - consequently,
the error code has not been heavily tested, and there are known bugs
in it. 

If you have found a bug, please mail it to the SCSI channel of the
mailing list with specifics of your hardware.  Other people may have the 
same problem, a solution, etc.

If you provide a patch, in context diff form, the bug will be fixed 
Immediately.  If you can provide me with a procedure that reproduces
the bug on *MY* system, the bug will be fixed "soon."  Your chances 
of getting it fixed increase exponentially with the amount of 
information provided.  If I can't reproduce it, and your 
description gives me no idea as to where in the code to  look,
it won't get fixed by me.

QUESTION: What are the known bugs?

ANSWER : 

Many of the drivers cannot abort a command that is in progress - if 
something goes haywire, all drives off that controller will hang.
 
QUESTION: I get a message saying READ CAPACITY FAILED. What does this
mean? 

ANSWER: UPGRADE.

QUESTION: Why does the system "hang" when SCSI disk access occurs.

ANSWER: Older Linux distributions (pre .97)  used  earlier versions
of the SCSI drivers, where the drivers were not interrupt driven
(easier debugging, or so we thought).  Since the drivers did not return
from the device driver strategy routine, until the SCSI command
completed, no other tasks were scheduled, and ineteractive performance
was abysmall. 

UPGRADE.

QUESTION: Why can't I swap to a SCSI disk?, Why can't I mount a SCSI
disk as root? 

ANSWER: This was due do a race condition that has since been fixed.

UPGRADE.

QUESTION: What future developments are planned?  

ANSWER: The following changes will/have occurred : 

        - have occurred : 

		- support for scatter / gather is there.  This 
		  means that all read (and readaheads) will be 
		  handled via one command.  

		- Significant changes have been made to the 
	          Seagate driver.  Among other things, it supports the
		  0ws line, which means we can dump data fast enough
		  to flood the bus.  

		- Multiple outstanding commands per LUN are supported.  
		  This should result in vastly improved performance
		  on multi-device systems.
	
		- SCSI tapes are supported.

		- Support for LUN !=0 is there.
	
	- Planned
		- SCSI commands are issued as linked commands
		  wherever possible, eliminating the arbitration / 
		  selection / message out phases needed to start 
		  a command "from scratch".

		- I have the mode page specs, and am looking at 
		  doing "appropriate things" w.r.t. cache enable,
		  buffer control, etc.  It seems that some drives
		  power up, and keep the buffer off until told otherwise
		  in software.

QUESTION: What drivers does the new code support.

ANSWER: ALL of the existing drivers work fine.  However, only the Adaptec,
Western Digital and Future Domain cards use scatter gather.  The seagate 
scatter/gather driver is fast but not yet stable and still kernel 
panics.

QUESTION: WHEN?

ANSWER: Now.  You just have to make sure that you are using version 0.98pl6
or later of the kernel, and you will automatically get the new scsi code.

XI.	NETWORKING and LINUX
============================
*** This section should be maintained by Philip Copeland
*** ([email-masked]). 

QUESTION: Where can I find useful information about networking for
Linux ?

ANSWER: Join the NET channel of the mailing list. Also, you need to
read the NET-FAQ by Phil Copeland, it's on sunsite and tsx-11 and
posted to c.o.l and the NET channel every couple of weeks.

Basically, all of the information on networking and TCP/IP for Linux
is in the NET-FAQ, because it's maintained seperately than this
document (and we don't want to waste the space reprinting it all
here--- it's big!).

The NET-FAQ has been completely rewritten as of Feb 1993. Get the new
version. 

XII. X11 THE MAXIMUM and MORE
=============================
*** This section is maintained by Krishna Balasubramanian
*** <[email-masked]>. Mail him if you have corrections,
*** additions, etc.
*** Last update: Tue, 16 Jan 93 19:06:57 -0500

XII.A. X386 GENERAL INFORMATION
XII.B. HARDWARE REQUIREMENTS: Supported Video cards.
XII.C. LINUX DISTRIBUTION: Files required, Current version.
XII.D. LEARNING/USING X: Pointers to X documentation.
XII.E. DEBUGGING STARTUP PROBLEMS: Checklist, Screen restoration, Hanging.
XII.F. XCONFIG: Video mode settings and common errors in Xconfig.
XII.G. X-APPLICATIONS: Compiling X programs.
XII.H. BUGS
XII.J. MISC: the things that I don't know where to put :)

The X11 directories are (depending on your version of X)
XLIB = /usr/X386/lib/X11/ or /usr/lib/X11/ 
XBIN = /usr/X386/bin/ or /usr/bin/X11/

XII.A. X386 GENERAL INFORMATION
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

QUESTION: What is the X11 release supported by Linux?

ANSWER: It's the X11R5 (xfree86-1.1). 

QUESTION: What is X386/xfree86?

ANSWER: X386 is the port of the X11 server to System V/386 that was
done by Thomas Roell ([email-masked]).  It supports a
wide variety of VGA boards.  X386 1.2 is included in MIT's X11R5
distribution.

The Linux X386 port was based on the stock distribution from X11R5,
from MIT and was done by Orest Zborowski ([email-masked]).

It has since moved to becoming part of the standard xfree86 distribution.

QUESTION: Where can I get X386 1.2 (X11R5)?

ANSWER: The X386 1.2 and xfree86 sources are available at any site that
distributes the X11R5 source (too numerous to list here, but includes
export.lcs.mit.edu)

QUESTION: Any tips on compiling X11R5?

ANSWER:
-  Dont do it.
-  XFree86 is distributed with a link kit so you can optionally
	include what you like in the server.
-  You will need lots of disk space (around 150Meg for the MIT core). 
-  Look at mit/server/ddx/x386/README and follow any instructions for
	your particular platform. 
-  Contact the X11 channel at linux-activists

XII.B  HARDWARE REQUIREMENTS:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Approx: at least 4 megs of ram + swap ...slooooww. 10 Meg disk for X.
Another 6-10 meg of disk for GCC if you want to compile X11 programs.

QUESTION: What VGA boards are supported?

ANSWER: 
	et3000, et4000, gvga, pvga1a, wd890c00, tvga8900, ati ver. 5 or 6,
        8514/A, generic vga: 800x600 mono (Xmono), 640x480x16 (Xega).

	Diamond cards are not supported and will not be supported.
Contact Diamond if you have further questions or (better) buy another card. 

Standard x11v1.1 or xfree86 server:
	ET3000 		(for ex. GENOA 5300/5400)
        ET4000 		(Tricom, STB PWR Graph, Sigma Legend, etc.)
        GVGA 		(Genoa 6400)
        PVGA1A 		(Paradise VGA Professional) ... see BUGS.
        WD90C00 	(Paradise VGA 1024)

supported by xfree86:
	TVGA8900 	TRIDENT 8900 support is in xfree86	

	ATI		ATI VGA WONDER XL and most ATI VGA WONDER PLUS 
			cards (chip version 5 or 6). 
			Courtesy Rik Faith ([email-masked])
ATI Notes: An example Xconfig file is available from ftp.cs.unc.edu:
/pub/faith/linux/x386. Please note that:
1) clock.exe does *NOT* work with ATI cards.  
2) The ATI Wonder driver in xFree86 is known only to work with 
   chip version 5 and 6 cards.  This is most ATI VGA Wonder PLUS cards 
   and all ATI VGA Wonder XL cards (although sporadic problems have been
   reported even with these very recent cards). The driver will tell 
   you which ATI chip version you have, as will the ati.test program in
   XLIB/etc/ 

MONO    Any vga card should be able to use X386mono server. (At least
	640x480 with 800x600 virtual). Use vga2 section of Xconfig.

Also available as ALPHA test versions (join the X11 channel):
(The standard x386/xfree86 server will not handle the following cards)

8514	ATI graphics ULTRA, ATI graphics Vantage 
	(should work with any VESA standard 8514/A register compatible card?)  
	tsx-11 pub/linux/packages/X11/X8514/  (X8514new.T.Z x.8514.src.T.Z)
	courtesy Kevin Martin ([email-masked]).

Xega	Generic 640x480x16 compatible server (originally for laptops).
	This requires a microsoft mouse at /dev/mouse for now
	and it does not use Xconfig so use environment variables
	to define the font path etc. in .xinitrc:
	export FONT_PATH=/usr/lib/X11/fonts/misc:/usr/lib/X11/fonts75dpi
	Works better with courier fonts so add to .Xresources:  
	*Font: -*-courier-medium-r-*--10* ..or whatever..
	A link kit is available at tsx-11 (you need gcc2.2.2).
	in pub/linux/ALPHA/Xega/X386.ega.T.Z
	courtesy Marc Hoffman ([email-masked]).

The Xega server is compiled with the gcc-2.2.2 libs and should be 
upgraded soon. It should however work with programs/fonts in new X11
releases as long as you ensure you have the shared images needed by
the server in /lib.

XS3	S3 chipset server (Jon Tombs [email-masked])
I've started a FAQ on ftp.robots.ox.ac.uk (pub/linux/S3), but the Xserver 
is still very alpha. Unless you know something about X386 and are prepared 
to work at it, stick with the mono XFree86 server until you see different 
advice. I'd hope to get the server integrated with XFree86 in the next 
couple of weeks. This will make most the current problems go away.

WARNING: Do not try to bring up an Xserver that does not support your 
hardware. There have been cases where damage has resulted from pushing
the monitor beyond its specs.

QUESTION: What Mouses are supported?

ANSWER: Serial : Logitech, Microsoft, MouseSystems .... compatibles ...
	Busmouses : Logitech, microsoft, ATI_XL, PS/2 (aux).

QUESTION: Has anyone gotten the "Mini-DIN" mouse on an HP Vectra 486/33T 
to work? The slight info I've been able to find says it's PS/2 compatible.

ANSWER: First you need to create an entry in /dev for it:

mknod /dev/psaux c 10 1

There is no direct PS/2 mouse support in XFree86 yet, so to use the
mouse with X you'll have to use the mconv mouse protocol conversion
utility, which can be found on nic.funet.fi, in
/pub/OS/Linux/utils/tools/mconv.c. This program converts the packets
sent by the PS/2 mouse into the corresponding ones from a Microsoft
mouse, so you can fool X telling it you have a Microsoft serial
mouse instead. Instructions for use are included in the source file.
(Johan Myreen [email-masked])

XII.C. LINUX DISTRIBUTION
~~~~~~~~~~~~~~~~~~~~~~~~~

QUESTION: What is the current version?

ANSWER:	The newest public Linux release is x11v2.1. It is the linux 
release of xfree86-1.1. It was compiled with gcc-2.2.2d and is available 
for example at tsx-11 in pub/linux/packages/X11/xfree86-1.1/
The SLS distribution stays at 2.0.

QUESTION: What Files do I need to download?

ANSWER: For x11v2.1: There is a README file in the distribution directory.
Bring this down first and read it. Then get xbin, xman and xfonts.
You need xprog and xlibman only if you plan to compile X applications.
You dont need xkit if you want to relink the server.

**** You need The shared images libc.so.4 (4.1 or later) and libm.so.4 (4.0) 
in /lib/. All the X11 binaries use these. To compile programs you should
get gcc-2.2.2d7 or later and the 4.x libraries.

For Other servers see also the notes in the previous section.

QUESTION: Where do the X11 files go? What are they?

ANSWER: x11v2.1 uses the directories /usr/X386/bin/ (XBIN) for programs
and /usr/X386/lib/X11/ (XLIB) for support files.

The support files include default/example Xconfig, xinitrc, twmrc
which you should copy to your HOME directory (as Xconfig, .xinitrc
and .twmrc) and edit them to define your hardware and X11 setup.
The directory XLIB/etc/ contains some documentation which
should explain how to configure your video.

XII.D.  LEARNING/USING X
~~~~~~~~~~~~~~~~~~~~~~~~

QUESTION: Where can I find the basic help for learning/using X ?

ANSWER: Try man X386; man Xserver; man xterm; man twm; man xinit
on any unix machine.  The man pages on xterm and twm will reflect
behaviour on Linux systems quite accurately. The others will give you
some bearing though not every option will work.  These man pages are
part of the xfree86 distribution.

QUESTION: What docs are available besides man pages?

ANSWER: The FAQ in comp.windows.x11 is extensive and has a bibliography. 
There is also the Xt-FAQ. Both are available from export.lcs.mit.edu in
pub/contrib/.

QUESTION: [suggested by Thomas Koenig]
	How do I support national keyboards in X11 ?

ANSWER: Put a .Xmodmap file into the user's home directory specifying
which keys to use for what; or else replace the
/usr/lib/X11/xinit/.Xmodmap with the national keyboard keys
customized. Do man xmodmap for more details. 
enclosed an excerpt of mine (french keyboard):
keycode   8 =
keycode   9 = Escape
keycode  10 = ampersand 1
keycode  11 = eacute 2 asciitilde
keycode  12 = quotedbl 3 numbersign
keycode  13 = apostrophe 4 braceleft
keycode  14 = parenleft 5 bracketleft
keycode  15 = minus 6 bar
keycode  16 = egrave 7 grave
keycode  17 = underscore 8 backslash
keycode  18 = ccedilla 9 asciicircum
keycode  19 = agrave 0 at
keycode  20 = parenright degree bracketright
keycode  21 = equal plus braceright
keycode  22 = BackSpace
keycode  23 = Tab
keycode  24 = A
........

XII.E. DEBUGGING STARTUP PROBLEMS:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

QUESTION: How do I start up X?

ANSWER: Type 'startx' at the shell prompt.
Before doing this you should:
1) copy the file Xconfig.sample from the XLIB directory to your 
	HOME directory (/usr/root/Xconfig?) or to XLIB/Xconfig.
2) Edit Xconfig and set the video data for you card and monitor. 
   Use the clocks appropriate for your card and the modes appropriate 
   for your monitor for those clock values. To determine what values are
   appropriate read files in XLIB/etc and the Xconfig section below. 
3) Set the mouse device in Xconfig correctly....Use the busmouse entry
   for Logitech only. For other busmouses use microsoft.
4) Ensure that there is a termcap entry for xterm in /etc/termcap
   (One is available in the subdir /doc).
5) Ensure that the X11 binaries are in the path example:
   add the line PATH=${PATH}:/usr/X386/bin to ~/.profile or
   look at bash.ad in /doc.
WARNING: NONE of the modes (in the Modes line in Xconfig) should use a 
clock your monitor cannot handle.
Now type startx.

QUESTION: I cannot type in my xterm 

ANSWER: /dev/console must have major=4, minor=0
	rm -f /dev/console; ln /dev/console /dev/tty0

QUESTION: What are some of the common omissions and errors?

ANSWER: (Peter)
1) Add /usr/bin/X11 (or /usr/X386/bin) to your path.

2) Add the xterm termcap entry to /etc/termcap.

3) ln -s X386 X in the XBIN directory.
   ln -s X386mono X (if you want to use the mono server).

4) Run X as root first. This avoids some trivial problems.

5) If you change the font path entry .... X386 is finicky about
   the syntax. 

6) Make sure your mouse entry in Xconfig points to a legitimate serial 
   device  (or busmouse)... usually something like:  microsoft "/dev/ttys1"
   serial devices have major # 4 minor 64,65 ... busmouses are major 10.
   ls -l in /dev will show you the major and minor entries.

7) Need read/write/exec access to /tmp directory 

8) Use startx 2> x.err to log your error messages. If the server sticks 
   and you have to reboot you'll probably loose this stuff... see notes
   on `hanging' below.

9) See Xconfig problems and the device list below.

10) Have you read the X386 man page?

QUESTION: Why is the server unable to find some of the fonts?

ANSWER: First check that the directories listed in the font path exist
and have font files in them. Some of the servers are not set up to use 
compressed fonts. In such cases you have to uncompress the fonts in the
directory and run `mkfontdir .`. Read the man page on mkfontdir.

QUESTION: My server "hangs" Why?

ANSWER: (Peter) Quite often it isn't a hang. If the server grabs the
screen(and enters graphics mode) and then dies, it may return you to
bash *without* restoring the screen. In other words, just because you
see no output, don't assume it's running/hanging.  The way to test
this is to see if you can use a bash command to spin your disk. eg.:
sync; ls -l /bin.

Also - I *suspect* that (at least for me), you can kill the
server if you include the servernum option in the Xconfig

You can kill the server when you want to by typing ctrl-alt-backspace. 
Then a couple of ctrl-C 's in case your stuck in xinit.

The two line message
 		X386 version .....
 		(protocol Version ....
is returned from the X386 programme itself, so if you get
this (or if the screen blanks) X must be starting.

QUESTION: When I try to use X11 I got "Cannot connect to
server" or "process does not exist", any clue ?

ANSWER: The cause might be wrong fontpath variable setup in your
Xconfig; uncomment and set the correct fontpath variable.

QUESTION: Why cant I run more than 4 xterms?
	  How can I have more than 4 pty's ?

ANSWER: set the number in the header include/linux/tty.h and 
recompile the kernel. Also make nodes :
	mknod /dev/ptypxx 4  minor  (where minor = 128 + xx)
	mknod /dev/ttypxx 4  minor  (minor = 192 + xx)
	This is for before linux-0.97pl6.... for later versions
	you only need to make the nodes.

QUESTION: I have trouble with my logitech Pilot mouse and X under
Linux, any clue ? 

ANSWER: (Thomas Roell?) There are TWO line of Logitech mice out there.
One is the programmable and uses MouseSystems protocol at startup.
X386 reprogramms them to use another protocol. If you specify
'Logitech' in the Xconfig, X386 assumes a mouse like C7 or S9 (notC7-M).
The second line is the MicroSoft compatible. Currently all newer
Logitech mice follows this practice, like the MouseMan. In that case
you have to say 'MicroSoft' or 'MouseMan'. 

From: [email-masked] (Jean Liddle)
I just purchased a new logitech mouseman, and yes, the new X-Windows
(XFree86 as opposed to X386) requires that you use the "microsoft" mousetype.
However, if you turn Third Button Emulation off, the middle button WILL work.

QUESTION: How does X11 start up?

ANSWER: The startup involves the server (XBIN/X), and some
programs like startx and xinit.

Typing startx runs the script  XBIN/startx. Look through startx. 
For explanation of the server arguments try man Xserver.
startx does little other than gather arguments and then call xinit.

xinit **calls** X (X is linked to X386). xinit therefore continues to
run, and quite often you will receive error messages from xinit rather
than X itself. If you get the message "giving up", it means X has died
(quite probably it died immediately) and xinit has been unable to start
x applications. xinit processes the startup script xinitrc.

QUESTION: How can I see what startx passes to xinit, and xinit to X?

ANSWER:  Add the line:  set -x      near the top of startx.

To see what xinit passes to X, try: (Peter)

	rm XBIN/X
 - yes, if you have set it up correctly, X should only be a link 
 so it's safe to remove it.

 then create a shell script XBIN/X containing:
	#/bin/sh
	echo $*
 and run startx. You should see something like:
	X :0
 which is all xinit passes to X. If you don't see the :0, you may not
 have your DISPLAY=":0" set correctly. THEN RESTORE X!! :
	cd XBIN; rm X; ln -s X386 X

QUESTION: What devices does X depend on:

ANSWER: check your device numbers with ls -l /dev. You should have:

5 0 tty
4 0 tty0
4 0 console
4 1 tty1 (etc)
1 1 mem

4 128 ptyp0 		pseudo ttys used by xterm/emacs etc 
4 129 ptyp1 (etc)	to talk to unix programs.
4 192 ttyp0
4 193 ttyp1 (etc)

4 64 ttys1 		one of these is the mouse 
4 65 ttys2		or you have a busmouse.
10 x mouse 		busmouse x = 0 => logitech 	1 => ps/2 (aux)
			2 => microsoft		3 => ATI_XL.
/tmp/.X11-unix/X0       socket used by X apps to talk to the server.
			this is created by X386.

XII.F. Xconfig: Xconfig and Video mode settings.
~~~~~~~~~~~~~~~
QUESTION: What do the mode names mean?

ANSWER: The mode names like "640x480" are used to match entries in 
the modes line with the modeDB entry which actually defines the mode. 
You can toggle between modes in the modes line  with ctrl-alt-numericplus. 
If you're experimenting with 640x480 you can define 
      modes "640x480a" "641x480b" "642x480c"
with corresponding entries under ModeDB so you can toggle between 
these three modes. Try man X386.

QUESTION: How do I compute the numbers for the video modes?

ANSWER: See if there is an entry that matches your chip/monitor in
XLIB/etc/modeDB.txt. Use the clock entries for your chip
and the mode entry for that clock appropriate for your monitor.
If you cant find a mode entry for a particular clock 'needed_clock'
but can find a mode entry (for your monitor) for a nearby clock value
'found_clock', scale all numbers in the modeDB entry by 
(needed_clock/found_clock). man X386 and Read CONFIG and Xconfig.notes.

QUESTION: How can I determine the clocks on the video chip?
	Where can I find clock.exe or clock.pas ?

ANSWER: The XFREE Team discourages the use  of clocks.exe and wants it
to be removed from all docs, since the new Server is better at
guessing the clocks than clocks.exe.

You can get X to tell you what it finds by commenting the
clocks entry in Xconfig. Use 'startx 2> x.err' to log the output.
If X starts up this file gets the clocks only after you exit.

I strongly advise using the 'modegen' spreadsheets to generate the 
appropriate settings. If I remember correctly you can find them in 
'pub/linux/packages/SLS/x4' called modegen.taz or something equally 
as obvious ... Good luck. (Andy [email-masked])

The clocks entry in Xconfig serves as an index. example: 
clocks 1 2 
ModeDB
1 640x480 .....
2 800x600 .....
means the first clock on the chip will be used for the 640x480 mode
and so on. Usually one uses the MHz value for the clock for convenience
instead of 1 2  you probably have 25 28 ... etc.

QUESTION: What are the settings used with a trident-8900C?

ANSWER: To get X/SLS/Linux working with a trident-8900C, do the following:

1) From Frank Houston [email-masked] 
vga256
  Virtual	1024 768
  ViewPort      0 0
  Modes	        "1024x768" "800x600" "640x480"
Use the VESA monitor timings from the modeDB in the example Xconfig.
You do not need to specify the chipset or clocks.

2) From: Henk Vandecasteele [email-masked] 
TRIDENT TVGA 8900C card with BIOS C2.11, A cheap color monitor AOC (CM-335) 
with a maximum horizontal frequence of 39.5
vga256
  Virtual	1024 1024
  ViewPort      0 0
  Modes        "912x684" "800x600" "640x480" 
# This mode drives my monitor to the limit (VESA timings for the rest).
 "912x684"     45      912  944 1104 1136    684  684  690  712 

QUESTION: What are common problems with Xconfig?

ANSWER: If X isn't firing at all, or even if it clears the screen and
crashes (see below) you almost certainly have a fault in Xconfig.

1. Note that the server X interprets Xconfig. (not xinit)

2. If you have a fault in Xconfig it is possible to crash or hang the
server without getting an error message.

3. leave the two paths at the top of Xconfig commented out when testing.

4. test with only one graphics mode included - one you are most sure of.

5. If you make a mistake in the mouse section, you will (I understand)
get an error message, so if you don't get some mouse error, try
elsewhere first. (eg "No such file or directory" indicates you have a
fault in the "/dev/ttyxx" line, or /dev/ttyxx doesn't exist.

6. *NB* X looks in your home directory first to find an Xconfig. make
certain it's using the one you've been working on!

7. you need double quotes (") around your chipset and modes: eg
	chipset "et4000"
	Modes   "640x480" "640x480a" "800x600"
and around the /dev/ttyxx eg.:
	microsoft "/dev/ttys1"

8. Check your VGA section and modeDB first.

9. ensure ModeDB clock speeds match the VGA section. Comment out any
unused lines in MODEDB.

eg  clocks  25 36 00 00 00 00 00 00 

then you *must* have (and only have) lines under modeDB corresponding
to speeds 25 and 36. If you have one with (say) 62 uncommented out in
the modeDB section in place of the 36 line, you will cause the server to
die immediately with no error message.

10. a syntax error (such as an unrecognised word) in Xconfig will cause
a death with no warning.

11. videoram must equal the amount of display ram on your chip.

QUESTION: What do I use in my Xconfig file to use the bus mouse?
Logitech doesn't work with my Logitech busmouse.

ANSWER: (Nathan I. Laredo)
Here are the mouse lines from my Xconfig:

BusMouse   "/dev/mouse"

You may add a sample rate if you want, but chances are, unless the model
number on your mouse matches mine: PC-93-9MD it probably will cause your
machine to lock up, as I've gotten several reports saying that.

According to the X386 documentation, non-logitech mice do not support
a sample rate.

XII.G X-APPLICATIONS: Compiling X Programs.
~~~~~~~~~~~~~~~~~~~~~

QUESTION: Does anyone know where I can find the libobz.a library ?

ANSWER: This library contained the socket stuff, when X386 V0.1 was
released. Meanwhile it has found it's way into the kernel, so
remove -lobz from the link step in the Makefile.

QUESTION: I get _setjmp undefined when linking xv from .a files.

ANSWER: You are trying to link a program compiled with gcc-2.2.2
and setjmp has changed sice then. Recompile xv from the source
using the latest gcc.

QUESTION: How do I compile an X application that has an Imakefile?

ANSWER:
	Type xmkmf to generate the Makefile.
	Type make.

QUESTION: gcc complains the X libraries are not found or links static.

ANSWER: Check out the -nojump -static options of GCC ... read the GCC FAQ.
	You can tell gcc what directories to search with -L. 

XII.H BUGS:
~~~~~~~~~~~
Restoration of the text screen fails on some hardware.

Cant compile Xaw programs without -static in versions x11v1.1 or older.
There is a glitch with the Xaw shared libs ... I haven't seen
this in a while anyway its fixed in newer releases.

Color problems with Xega .... fixed in latest version on tsx-11.

from [email-masked] (Chuck Sites)
It is possible to run X386 on a Paradise VGA Plus. The X386.0 doc file
has a small misprint.  The Chipset is not pvga. It's pvga1.   Anyway,
under the line in /usr/X386/lib/X11/Xconfig VGA256, add, `chipset "pvga1"`.
You will need a 512k board.  There seems to be a problem with 800x600 mode
that causes pixels to be misplaced in the center 1/3 of the screen. 640x480
works fine.  Anybody out there might have a fix for that? You may want to use
X386mono with 800x600 instead.

Fix for missing numlock control in xfree86-1.1.
use xmodmap to change the mapping:
  clear mod1
  add mod1 = Alt_L
  keysym Alt_R = Mode_switch
  add mod5 = Mode_switch
David (Dawes)

XII.J. MISC
~~~~~~~~~~~
QUESTION: When using Makefiles generated by xmkmf why do I get many error 
	messages?

ANSWER: Currently xmkmf under Linux doesn't like # comments in Imakefiles. 
Therefore you must change the #'s to XCOMM. But be careful. Don't change
any pre-compiler directives. ([email-masked]  Matthew A. Lewis)

QUESTION: Why do I get the  error message 'could not open default font'
	when I start X?

ANSWER: Some servers only work with compressed (uncompressed) fonts.
So compress (uncompress) the font files in misc and 75dpi directories and 
run `mkfontdir .`. Leave the files fonts.alias and fonts.dir uncompressed.

QUESTION: Why is it I cannot get Xfree86 to work with my trident card?

ANSWER: You should get xfree86-1.1 which has improved trident support.
SLS contains 1.0Ya (I believe). If you have SLS already and a slow 
connection get xbin2.1.TZa from the xfree86-1.1 distribution on tsx-11.

Sources for X11_FAQ: 
Steve Kotsopoulos, Peter Hawkins, John Morris, MM. Corsini, 
K. Balasubramanian. 
Direct comments, questions, complaints to krishna at:
[email-masked]

XIII. EMACS for LINUX
=====================
*** This section is maintained by Rick Sladkey ([email-masked])
*** Last Update November 1992.

XIII.A. GENERAL INFORMATION 
XIII.B. GNU EMACS for LINUX

XIII.A. GENERAL INFORMATION
~~~~~~~~~~~~~~~~~~~~~~~~~~~

This is a short list of Frequently Asked Questions about GNU Emacs
under Linux.  It does not address general questions about Emacs which
are not Linux specific.  For general help about Emacs, 1) learn to use
and read the online documentation, 2) read the real Emacs FAQ found in
emacs/etc/FAQ, and 3) read the newsgroup gnu.emacs.help.

                                        Rick Sladkey <[email-masked]>

XIII.B. GNU EMACS for LINUX
~~~~~~~~~~~~~~~~~~~~~~~~~~~
QUESTION: Does Linux Emacs use the shared libraries?

ANSWER: Yes.  It wasn't easy.  If you have any problems with them let
me know. Also contact me if you would like static binaries.

QUESTION: What version of the compiler was used?  Which shared libaries?

ANSWER: This describes version of GNU Emacs 18.59 for Linux 0.97 and above
compiled with GCC 2.2.2d7 using the libc.so.4.1 and libX11.so.2.1 shared
libraries.

QUESTION: Which files do I need?

ANSWER:
emacs-18.59a.tar.Z		this file, sample default.el and diffs
				for this version, the eight-bit patch,
				iso-latin-1.el and eight-bit.el
emacs-etc-18.59a.tar.Z		emacs support programs and misc info
emacs-bin-18.59a.tar.Z		shared emacs binary and its doc file
x11emacs-bin-18.59a.tar.Z	shared x11emacs binary and its doc file

QUESTION: How do I install them?

ANSWER: According to Linux convention, cd to /usr and untar the
packages. 

QUESTION: Does Linux Emacs support eight-bit input/output?

ANSWER: Yes.  It is new with this version.  It uses the so-called
"ctl-arrow" patch.  See the file README.8bit for more information.

QUESTION: How much disk space is required?

ANSWER: Anywhere from 1 to 15 Meg.  Emacs works reasonably well with no
support files at all.  With a judicious selection from lisp/*.elc and
etc/*, quite a lot can be done using only 2 Meg.  If you want all of
lisp/*.elc, info/*, and etc/* this will require 4 to 6 Meg.  If you
unpack the whole source you need 8 Meg.  If you collect info files
like rare coins and install a lot of big lisp packages then Emacs may
need its own partition. :-)

QUESTION: Why does Emacs crash under Linux 0.98 patchlevel 4 or higher?

ANSWER: It crashes becuase of the a new 256-bit wide fd_set structure. 
Sometimes progress requires sacrifice.

QUESTION: Why can't Emacs find its support files anymore?

ANSWER: This is because older versions of Emacs were compiled with
"/usr/local/emacs" based paths.  The current version is compiled with
"/usr/emacs" paths.  If you have a previous installation, just "mv
/usr/local/emacs /usr" and you're done.  If you can't bear to part
with the "/usr/local" pathnames because of inertia then do "ln -s
/usr/local/emacs /usr" and you can have them both.

QUESTION: How do I get Emacs to recognize my cursor keys?

ANSWER: Simple.  Don't use them. :-)  Seriously, there are as many
ways to do this are there are elisp hackers but the preferred way is
to follow the pattern set by the other terminal definition files in
emacs/lisp/term/*.el.  For just arrow keys you can just copy vt220.el
to console.el and that's it.  For function keys and the others see
the sample default.el included with this file.

QUESTION: What packages are particularly useful under Linux?

ANSWER: Because info format is the documentation standard of the GNU
project and just about everything except the kernel comes from FSF,
you will find that Dave Gillespie's enhanced info package is very
useful.  It allows multiple info directories, space bar paging, and
supports compressed info files. Please learn to use info.  Imagine
Unix life without man.

Others that I highly recommend are Sebastian Kremer's enhanced
dired directory editor, Dave Gillespie's calc calculator, Masanobu
UMEDA's gnus for usenet news, and Kyle Jone's vm for mail.

All can be found in the OSU Emacs archive.  See the real FAQ for more
details.

QUESTION: Does Linux Emacs use the shared libraries?

ANSWER: Yes.  It is very delicate.  Emacs uses its own malloc and the
library uses the standard one.  Everything works as long as the two
never meet. 

QUESTION: Does Linux Emacs support the X Window System?

ANSWER: Yes.  However, there are two binaries.  One without X support
(about 485k) and one with X support (about 515k).

QUESTION: Do I need both Emacs if I don't always use X?

ANSWER: No. The X11 version works equally well inside or outside of X.
If you get the message "Check your DISPLAY variable" it means that
you have defined DISPLAY in your ~/.profile (or whatever).  You can
fix this by starting Emacs with 'emacs -nw' or by removing the DISPLAY
variable from your ~/.profile and putting it in you ~/.xinitrc.

QUESTION: Why doesn't Emacs use the settings in my
.Xdefaults/.Xresources file? 

ANSWER: You are probably using the word "emacs" and your X version of
emacs is called x11emacs.  Either use the word "Emacs" in your resource
file or rename x11emacs to emacs.  See above question on why this
is reasonable.

QUESTION: I read about some menu that is supposed to pop up when I
press some mouse button.  Does this work with Linux Emacs?

ANSWER: Yes.  This requires XMenu support to be compiled in.  Former
versions did not support it because it did not work correctly.

QUESTION: Sometimes Emacs crashes with a SIGALRM message.  What's
wrong? 

ANSWER: You need to upgrade to a newer version of bash.  Some older
versions of bash were compiled with buggy libraries that caused bash
to send a SIGALRM to its parent in some circumstances.  Recent
versions do not exhibit this problem.

QUESTION: Why does Emacs always put me in the root directory?

ANSWER: You have an old version of Emacs compiled before GCC 2.11c and
you are using the Linux extended filesystem.  Get the new version.

QUESTION: Why doesn't Control-Z doesn't work right with Emacs?

QUESTION: Why doesn't job control work in shell mode?

ANSWER: You have a really old version of Linux Emacs.  Get the new one.

	   ===================8<==========>8================

-- 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#	LaBRI 			 |					    #
#  351 cours de la Liberation    |  e-mail:  [email-masked]    #
#  33405 Talence Cedex		 |					    #
#  				 |					    #
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- 
	 There will be a sig when our local net is reliable.
	       For now, I would rather stay anonymous.